<?php
$filename = 'attachmentedit.php';

require('./global.php');
$lang->load('MISC');


if (!checkpermissions('can_upload_attachments') || (isset($board) && is_array($board) && ($board['isboard'] != 1 || $board['closed'] == 1))) {
	eval("\$tpl->output(\"".$tpl->get("window_close")."\");");
	exit();
}


$uploaderror = '';

// delete existing attachment
if (isset($_POST['action']) && $_POST['action'] == 'del') {
	if (isset($attachmentid)) {
		if (!checkmodpermissions('m_can_post_edit') && $attachment['userid'] != 0 && ($wbbuserdata['userid'] == 0 || $attachment['userid'] != $wbbuserdata['userid'] || !checkpermissions('can_edit_own_post'))) access_error();
		
		@unlink("attachments/attachment-".$attachmentid.".".$attachment['attachmentextension']);
		$db->unbuffered_query("DELETE FROM bb".$n."_attachments WHERE attachmentid = '$attachmentid'", 1);
	}
	eval("\$tpl->output(\"".$tpl->get("window_close")."\");");
	exit();
}

// add new attachment
if (isset($_POST['action']) && $_POST['action'] == 'add') {
	if (isset($attachmentid)) {
		if (!checkmodpermissions('m_can_post_edit') && $attachment['userid'] != 0 && ($wbbuserdata['userid'] == 0 || $attachment['userid'] != $wbbuserdata['userid'] || !checkpermissions('can_edit_own_post'))) access_error();
		
		@unlink('attachments/attachment-'.$attachmentid.'.'.$attachment['attachmentextension']);
		$db->unbuffered_query("DELETE FROM bb".$n."_attachments WHERE attachmentid = '$attachmentid'", 1);
	}
	if ($_FILES['attachment_file']['tmp_name'] && $_FILES['attachment_file']['tmp_name'] != 'none') {
		$attachment_file_extension = wbb_strtolower(wbb_substr(strrchr($_FILES['attachment_file']['name'], '.'), 1));
		$attachment_file_name2 = wbb_substr($_FILES['attachment_file']['name'], 0, (intval(wbb_strlen($attachment_file_extension)) + 1) * -1);
		
		$allowextensions = str_replace("\n", "|", str_replace('*', '[a-z0-9]*', $wbbuserdata['allowed_attachment_extensions']));
		if (preg_match("/^($allowextensions)$/i", $attachment_file_extension) && $_FILES['attachment_file']['size'] <= $wbbuserdata['max_attachment_size']) {
			// attachment extension is allowed
			$db->query("INSERT INTO bb".$n."_attachments (attachmentid,attachmentname,attachmentextension,attachmentsize) VALUES (NULL,'".addslashes($attachment_file_name2)."','".addslashes($attachment_file_extension)."','".$_FILES['attachment_file']['size']."')");
			$attachmentid = $db->insert_id();
			
			if (@move_uploaded_file($_FILES['attachment_file']['tmp_name'], 'attachments/attachment-'.$attachmentid.'.'.$attachment_file_extension)) {
				@chmod('attachments/attachment-'.$attachmentid.'.'.$attachment_file_extension, 0777);
				$attachment_file_name2 = str_replace("'", "\'", $attachment_file_name2);
				$attachment_file_extension = str_replace("'", "\'", $attachment_file_extension);
				eval("\$tpl->output(\"".$tpl->get("attachmentedit_give_parent")."\");");
				exit();
			}
			else {
				// could not copy uploaded file, rollback insert statement
				$db->unbuffered_query("DELETE FROM bb".$n."_attachments WHERE attachmentid='$attachmentid'", 1);
				$uploaderror = 1;
			}
		}
		else $uploaderror = 1;
	}
	else $uploaderror = 1;
	if ($uploaderror == 1) eval("\$uploaderror = \"".$tpl->get("attachmentedit_error")."\";");
		
	unset($attachmentid);
}

if (isset($attachmentid)) {
	if (!checkmodpermissions('m_can_post_edit') && $attachment['userid'] != 0 && ($wbbuserdata['userid'] == 0 || $attachment['userid'] != $wbbuserdata['userid'] || !checkpermissions('can_edit_own_post'))) access_error();
	
	$allowed_attachment_extensions		= getAllowedExtensions($wbbuserdata['allowed_attachment_extensions']);
	$max_attachment_size			= formatFilesize($wbbuserdata['max_attachment_size']);
	$attachment['attachmentname']		= htmlconverter($attachment['attachmentname']);
	$attachment['attachmentextension']	= htmlconverter($attachment['attachmentextension']);
	
	eval("\$tpl->output(\"".$tpl->get("attachmentedit_edit")."\");");
}
else {
	$allowed_attachment_extensions	= getAllowedExtensions($wbbuserdata['allowed_attachment_extensions']);
	$max_attachment_size		= formatFilesize($wbbuserdata['max_attachment_size']);
	eval("\$tpl->output(\"".$tpl->get("attachmentedit_add")."\");");
}
?>