<?php
$filename = 'pms.php';

require('./global.php');
require('./acp/lib/class_parse.php');
require('./acp/lib/class_parsecode.php');
$lang->load('PMS,USERCP');

if (!$wbbuserdata['userid'] || $wbbuserdata['can_use_pms'] == 0) access_error();

if (isset($_REQUEST['folderid'])) $folderid = $_REQUEST['folderid'];
else $folderid = '0';

if (isset($_REQUEST['action'])) $action = $_REQUEST['action'];
else $action = '';

$username = htmlconverter($wbbuserdata['username']);
$lang->items['LANG_USERCP_TITLE'] = $lang->get("LANG_USERCP_TITLE", array('$username' => $username));

if ($action == '' || $action == 'tracking') {
	$pmcount = 0;
	$inbox_count = 0;
	$tracking_count = 0;
	$outbox_count = 0;
	$temp_folder_count = array();

	$result = $db->unbuffered_query("SELECT folderid, recipientid, senderid, deletepm, tracking FROM bb".$n."_privatemessage WHERE recipientid='$wbbuserdata[userid]' || senderid='$wbbuserdata[userid]'");
	while ($row = $db->fetch_array($result)) {
		if ($row['recipientid'] == $wbbuserdata['userid'] && $row['deletepm'] != 1) {
			$pmcount++;
			if ($row['folderid'] == 0) $inbox_count++;
			else {
				if (isset($temp_folder_count[$row['folderid']])) $temp_folder_count[$row['folderid']]++;
				else $temp_folder_count[$row['folderid']] = 1;
			}
		}
		if ($row['senderid'] == $wbbuserdata['userid'] && $row['deletepm'] != 2) {
			$pmcount++;
			$outbox_count++;
		}
		if ($row['senderid'] == $wbbuserdata['userid'] && $row['tracking'] == 1) $tracking_count++;
	}

	$temp = $pmcount / $maxpms;
	if (($percent = round($temp * 100)) > 100) {
		$percent = 100;
		$temp = 1;
	}
	
	$lang->items['LANG_PMS_FOLDER_USAGE'] = $lang->get("LANG_PMS_FOLDER_USAGE", array('$percent' => $percent));
	$x = round($temp * 240);

	if (isset($_REQUEST['daysprune'])) $daysprune = intval($_REQUEST['daysprune']);
	elseif ($wbbuserdata['daysprune'] != 0) $daysprune = $wbbuserdata['daysprune'];
	else $daysprune = $default_daysprune;

	if ($daysprune == 1000) $datecute = 0;
	elseif ($daysprune == 1500) $datecute = $wbbuserdata['lastvisit'];
	else $datecute = time() - $daysprune * 86400;

	$d_select[1] = '';
	$d_select[2] = '';
	$d_select[5] = '';
	$d_select[10] = '';
	$d_select[20] = '';
	$d_select[30] = '';
	$d_select[45] = '';
	$d_select[60] = '';
	$d_select[75] = '';
	$d_select[100] = '';
	$d_select[365] = '';
	$d_select[$daysprune] = ' selected="selected"';

	$result = $db->query("SELECT folderid, title FROM bb".$n."_folders WHERE userid='$wbbuserdata[userid]' ORDER BY title ASC");
	$user_folder_count = $db->num_rows($result);
	$folder_bit = '';
	$moveto_options = '';
	$folder['title'] = '';
	while ($row = $db->fetch_array($result)) {
		if (isset($temp_folder_count[$row['folderid']])) $folder_count = $temp_folder_count[$row['folderid']];
		else $folder_count = 0;

		$row['title'] = htmlconverter($row['title']);
		eval("\$folder_bit .= \"".$tpl->get("pms_folderbit")."\";");
		if ($row['folderid'] == $folderid) $folder['title'] = $row['title'];
		else {
			eval("\$moveto_options .= \"".$tpl->get("pms_moveto_options")."\";");
		}
	}
}


/* view pms from folder x */
if ($action == '') {
	if ($folderid != 'outbox' && $folderid != 0 && !$folder['title']) access_error();
	if (!$folder['title']) $folder['title'] = $lang->items['LANG_PMS_INBOX'];
	$pms_bit = '';

	if ($folderid == 'outbox') {
		$moveto_options = '';
		$result = $db->unbuffered_query("SELECT
		p.privatemessageid, p.subject, p.sendtime, p.iconid,
		i.iconpath, i.icontitle,
		u.userid, u.username
		FROM bb".$n."_privatemessage p
		LEFT JOIN bb".$n."_icons i USING(iconid)
		LEFT JOIN bb".$n."_users u ON (p.recipientid=u.userid)
		WHERE p.senderid='$wbbuserdata[userid]' AND p.deletepm<>2 AND p.sendtime>'$datecute'
		ORDER BY sendtime DESC");
		while ($row = $db->fetch_array($result)) {
			if ($row['iconid']) $icon = makeimgtag($row['iconpath'], getlangvar($row['icontitle'], $lang), 0);
			else $icon = "&nbsp;";

			$senddate = formatdate($wbbuserdata['dateformat'], $row['sendtime']);
			$sendtime = formatdate($wbbuserdata['timeformat'], $row['sendtime']);

			$row['username'] = htmlconverter($row['username']);
			$row['subject'] = htmlconverter($row['subject']);
			eval("\$pms_bit .= \"".$tpl->get("pms_bit")."\";");
		}

		eval("\$tpl->output(\"".$tpl->get("pms")."\");");
	}
	else {
		$result = $db->unbuffered_query("SELECT
		p.privatemessageid, p.subject, p.sendtime, p.view, p.reply, p.forward, p.iconid,
		i.iconpath, i.icontitle,
		u.userid, u.username
		FROM bb".$n."_privatemessage p
		LEFT JOIN bb".$n."_icons i USING(iconid)
		LEFT JOIN bb".$n."_users u ON (p.senderid=u.userid)
		WHERE p.recipientid='$wbbuserdata[userid]' AND p.deletepm<>1 AND p.folderid='".addslashes($folderid)."' AND p.sendtime>'$datecute'
		ORDER BY sendtime DESC");
		while ($row = $db->fetch_array($result)) {
			if ($row['iconid']) $icon = makeimgtag($row['iconpath'], getlangvar($row['icontitle'], $lang), 0);
			else $icon = "&nbsp;";

			$senddate = formatdate($wbbuserdata['dateformat'], $row['sendtime']);
			$sendtime = formatdate($wbbuserdata['timeformat'], $row['sendtime']);

			if ($row['sendtime'] >= $wbbuserdata['lastvisit'] && $row['view'] == 0) $pm_image = makeimgtag("{$style[imagefolder]}/pm_new.gif");
			elseif ($row['view'] == 0) $pm_image = makeimgtag("{$style[imagefolder]}/pm_unread.gif");
			else {
				if ($row['reply'] == 1 && $row['forward'] == 1) $pm_image = makeimgtag("{$style[imagefolder]}/pm_reward.gif");
				elseif ($row['reply'] == 1) $pm_image = makeimgtag("{$style[imagefolder]}/pm_reply.gif");
				elseif ($row['forward'] == 1) $pm_image = makeimgtag("{$style[imagefolder]}/pm_forward.gif");
				else $pm_image = makeimgtag("{$style[imagefolder]}/pm_normal.gif");
			}

			$row['username'] = htmlconverter($row['username']);
			$row['subject'] = htmlconverter($row['subject']);
			eval("\$pms_bit .= \"".$tpl->get("pms_bit")."\";");
		}

		eval("\$tpl->output(\"".$tpl->get("pms")."\");");
	}
	exit;
}

/** message tracking **/
if ($action == 'tracking') {
	$lang->load('MEMBERS');

	$readbit = '';
	$unreadbit = '';
	$read = '';
	$unread = '';
	$activtime = time() - 60 * $useronlinetimeout;
	$result = $db->unbuffered_query("SELECT p.privatemessageid, p.recipientid, p.subject, p.view, p.sendtime, u.username, u.invisible, u.lastactivity, i.iconpath, i.icontitle FROM bb".$n."_privatemessage p
	LEFT JOIN bb".$n."_icons i USING (iconid)
	LEFT JOIN bb".$n."_users u ON (u.userid=p.recipientid)
	WHERE p.senderid='$wbbuserdata[userid]' AND p.tracking=1 AND p.sendtime>'$datecute'
	ORDER BY sendtime DESC");
	while ($row = $db->fetch_array($result)) {
		$senddate = formatdate($wbbuserdata['dateformat'], $row['sendtime']);
		$sendtime = formatdate($wbbuserdata['timeformat'], $row['sendtime']);

		$row['subject'] = htmlconverter($row['subject']);
		$row['username'] = htmlconverter($row['username']);
		$username = $row['username'];
		if ($row['lastactivity'] >= $activtime && ($row['invisible'] == 0 || $wbbuserdata['a_can_view_ghosts'] == 1)) {
			$user_online = 1;
			$LANG_MEMBERS_USERONLINE = $lang->get("LANG_MEMBERS_USERONLINE", array('$username' => $username));
		}
		else {
			$user_online = 0;
			$LANG_MEMBERS_USEROFFLINE = $lang->get("LANG_MEMBERS_USEROFFLINE", array('$username' => $username));
		}

		if ($row['iconid']) $icon = makeimgtag($row['iconpath'], getlangvar($row['icontitle'], $lang), 0);
		else $icon = "&nbsp;";

		if ($row['view'] == 0) eval("\$unreadbit .= \"".$tpl->get("pms_tracking_unreadbit")."\";");
		else {
			$readdate = formatdate($wbbuserdata['dateformat'], $row['view']);
			$readtime = formatdate($wbbuserdata['timeformat'], $row['view']);
			eval("\$readbit .= \"".$tpl->get("pms_tracking_readbit")."\";");
		}
	}

	$folder['title'] = $lang->get('LANG_PMS_TRACKING');
	if ($readbit) eval("\$read = \"".$tpl->get("pms_tracking_read")."\";");
	if ($unreadbit) eval("\$unread = \"".$tpl->get("pms_tracking_unread")."\";");

	eval("\$tpl->output(\"".$tpl->get("pms")."\");");
	exit;
}

/** create a folder **/
if (isset($_POST['action']) && $_POST['action'] == 'createfolder') {
	$foldertitle = wbb_trim($_POST['foldertitle']);
	if (!$foldertitle) redirect($lang->items['LANG_PMS_REDIRECT_FALSEFOLDER'], "pms.php".$SID_ARG_1ST, 5);

	list($foldercount) = $db->query_first("SELECT COUNT(*) FROM bb".$n."_folders WHERE userid='$wbbuserdata[userid]'");
	if ($foldercount >= $maxfolders) redirect($lang->items['LANG_PMS_TOOMANYFOLDERS'], "pms.php".$SID_ARG_1ST, 5);

	$db->query("INSERT INTO bb".$n."_folders (folderid,userid,title) VALUES (NULL,'$wbbuserdata[userid]','".addslashes($foldertitle)."')");
	$folderid = $db->insert_id();

	header("Location: pms.php?folderid=$folderid".$SID_ARG_2ND_UN);
	exit;
}

/** rename a folder **/
if (isset($_POST['action']) && $_POST['action'] == 'renamefolder') {
	$foldertitle = wbb_trim($_POST['foldertitle']);
	$folderid = intval($_POST['folderid']);

	list($controluser) = $db->query_first("SELECT userid FROM bb".$n."_folders WHERE folderid='$folderid'");
	if ($controluser != $wbbuserdata['userid']) access_error();

	$db->unbuffered_query("UPDATE bb".$n."_folders SET title = '".addslashes($foldertitle)."' WHERE folderid='$folderid'", 1);
	header("Location: pms.php?folderid=$folderid".$SID_ARG_2ND_UN);
	exit;
}

/** remove a folder **/
if (isset($_GET['action']) && $_GET['action'] == 'removefolder') {
	$folderid = intval($_GET['folderid']);

	list($controluser) = $db->query_first("SELECT userid FROM bb".$n."_folders WHERE folderid='$folderid'");
	if ($controluser != $wbbuserdata['userid']) access_error();

	$db->unbuffered_query("UPDATE bb".$n."_privatemessage SET folderid = '0' WHERE folderid='$folderid'", 1);
	$db->unbuffered_query("DELETE FROM bb".$n."_folders WHERE folderid='$folderid'", 1);

	header("Location: pms.php".$SID_ARG_1ST);
	exit;
}

/** delete marked msgs **/
if (isset($_POST['action']) && $_POST['action'] == 'delmark') {
	if ($_POST['pmid'] && count($_POST['pmid'])) $pmids = implode(',', $_POST['pmid']);
	else $pmids = '';
	if ($pmids) {
		if ($_POST['folderid'] == "outbox") {
			$db->query("DELETE FROM bb".$n."_privatemessage WHERE senderid='$wbbuserdata[userid]' AND deletepm=1 AND privatemessageid IN (".addslashes($pmids).")");
			$db->unbuffered_query("UPDATE bb".$n."_privatemessage SET deletepm=2 WHERE senderid='$wbbuserdata[userid]' AND privatemessageid IN (".addslashes($pmids).")", 1);
		}
		else {
			$db->query("DELETE FROM bb".$n."_privatemessage WHERE recipientid='$wbbuserdata[userid]' AND deletepm=2 AND privatemessageid IN (".addslashes($pmids).")");
			$db->unbuffered_query("UPDATE bb".$n."_privatemessage SET deletepm=1, tracking=0 WHERE recipientid='$wbbuserdata[userid]' AND privatemessageid IN (".addslashes($pmids).")", 1);
		}
	}
	header("Location: pms.php?folderid=$folderid".$SID_ARG_2ND_UN);
	exit;
}

/** delete all msgs **/
if (isset($_POST['action']) && $_POST['action'] == 'delall') {
	if ($_POST['folderid'] == "outbox") {
		$db->query("DELETE FROM bb".$n."_privatemessage WHERE senderid='$wbbuserdata[userid]' AND deletepm=1");
		$db->unbuffered_query("UPDATE bb".$n."_privatemessage SET deletepm=2 WHERE senderid='$wbbuserdata[userid]'", 1);
	}
	else {
		$db->query("DELETE FROM bb".$n."_privatemessage WHERE recipientid='$wbbuserdata[userid]' AND folderid='".intval($_POST['folderid'])."' AND deletepm=2");
		$db->unbuffered_query("UPDATE bb".$n."_privatemessage SET deletepm=1, tracking=0 WHERE recipientid='$wbbuserdata[userid]' AND folderid='".intval($_POST['folderid'])."'", 1);
	}
	header("Location: pms.php?folderid=$folderid".$SID_ARG_2ND_UN);
	exit;
}

/** view a pm **/
if (isset($_GET['action']) && $_GET['action'] == 'viewpm') {
	if (isset($_GET['outbox'])) {
		$pmid = intval($_GET['pmid']);
		$pm = $db->query_first("SELECT
		p.*,
		i.iconpath, i.icontitle,
		u.userid, u.username, u.signature
		FROM bb".$n."_privatemessage p
		LEFT JOIN bb".$n."_icons i USING(iconid)
		LEFT JOIN bb".$n."_users u ON (p.recipientid=u.userid)
		WHERE p.privatemessageid='$pmid' AND p.deletepm<>2");
		if ($pm['senderid'] != $wbbuserdata['userid']) error($lang->get("LANG_GLOBAL_ERROR_FALSELINK", array('$adminmail' => $adminmail)));

		$senddate = formatdate($wbbuserdata['dateformat'], $pm['sendtime']);
		$sendtime = formatdate($wbbuserdata['timeformat'], $pm['sendtime']);
		if ($pm['iconid']) $icon = makeimgtag($pm['iconpath'], getlangvar($pm['icontitle'], $lang), 0);
		else $icon = '';

		$parse = &new parse($docensor, 90, $wbbuserdata['showimages'], "", $usecode);
		$pm['message'] = $parse->doparse($pm['message'], $pm['allowsmilies'], $pm['allowhtml'], $pm['allowbbcode'], $pm['allowimages']);
		$pm['subject'] = htmlconverter(textwrap($pm['subject']));
		if ($pm['showsignature'] == 1 && !$wbbuserdata['disablesignature'] && $wbbuserdata['showsignatures'] == 1 && $wbbuserdata['signature']) {
			$posts['signature'] = $parse->doparse($wbbuserdata['signature'], $wbbuserdata['allowsigsmilies'], $wbbuserdata['allowsightml'], $wbbuserdata['allowsigbbcode'], $wbbuserdata['allowsigimages']);
			eval("\$signature = \"".$tpl->get("thread_signature")."\";");
		}

		$pm['username'] = htmlconverter($pm['username']);
		$lang->items['LANG_PMS_MESSAGE_TO_USER'] = $lang->get("LANG_PMS_MESSAGE_TO_USER", array('$username' => $pm['username'], '$senddate' => $senddate, '$sendtime' => $sendtime));
		eval("\$tpl->output(\"".$tpl->get("pms_viewpm_outbox")."\");");
	}
	else {
		$pmid = intval($_GET['pmid']);
		$pm = $db->query_first("SELECT
		p.*, f.*,
		i.iconpath, i.icontitle,
		u.userid, u.username, u.signature, u.allowsigsmilies, u.allowsightml, u.allowsigbbcode, u.allowsigimages, u.disablesignature
		FROM bb".$n."_privatemessage p
		LEFT JOIN bb".$n."_icons i USING(iconid)
		LEFT JOIN bb".$n."_users u ON (p.senderid=u.userid)
		LEFT JOIN bb".$n."_folders f ON (p.folderid=f.folderid)
		WHERE p.privatemessageid='$pmid' AND p.deletepm<>1");
		if ($pm['recipientid'] != $wbbuserdata['userid']) error($lang->get("LANG_GLOBAL_ERROR_FALSELINK", array('$adminmail' => $adminmail)));
		if ($pm['view'] == 0) $db->unbuffered_query("UPDATE bb".$n."_privatemessage SET view='".time()."' WHERE privatemessageid='$pmid'", 1);

		$senddate = formatdate($wbbuserdata['dateformat'], $pm['sendtime']);
		$sendtime = formatdate($wbbuserdata['timeformat'], $pm['sendtime']);
		if ($pm['iconid']) $icon = makeimgtag($pm['iconpath'], getlangvar($pm['icontitle'], $lang), 0);
		else $icon = '';

		if ($pm['folderid'] == 0) $pm['title'] = $lang->items['LANG_PMS_INBOX'];
		else $pm['title'] = htmlconverter($pm['title']);
		$parse = &new parse($docensor, 90, $wbbuserdata['showimages'], "", $usecode);
		$pm['message'] = $parse->doparse($pm['message'], $pm['allowsmilies'], $pm['allowhtml'], $pm['allowbbcode'], $pm['allowimages']);
		$pm['subject'] = htmlconverter(textwrap($pm['subject']));
		if ($pm['showsignature'] == 1 && !$pm['disablesignature'] && $wbbuserdata['showsignatures'] == 1 && $pm['signature']) {
			$posts['signature'] = $parse->doparse($pm['signature'], $pm['allowsigsmilies'], $pm['allowsightml'], $pm['allowsigbbcode'], $pm['allowsigimages']);
			eval("\$signature = \"".$tpl->get("thread_signature")."\";");
		}

		$pm['username'] = htmlconverter($pm['username']);
		$lang->items['LANG_PMS_MESSAGE_FROM_USER'] = $lang->get("LANG_PMS_MESSAGE_FROM_USER", array('$username' => $pm['username'], '$senddate' => $senddate, '$sendtime' => $sendtime));
		eval("\$tpl->output(\"".$tpl->get("pms_viewpm")."\");");
	}
	exit;
}

/** create a new pm **/
if ($_REQUEST['action'] == 'newpm' || $_REQUEST['action'] == 'replypm' || $_REQUEST['action'] == 'forwardpm') {
	$lang->load('POSTINGS,MAIL');

	/* checkbox preselect */
	if ($newpm_default_checked_0 == 1) $checked[0] = 'checked="checked"';
	if ($newpm_default_checked_1 == 1) $checked[1] = 'checked="checked"';

	if ($newpm_default_checked_5 == 1) $checked[5] = 'checked="checked"';
	if ($newpm_default_checked_6 == 1) $checked[6] = 'checked="checked"';
	if ($newpm_default_checked_7 == 1) $checked[7] = 'checked="checked"';


	if ($newpm_default_checked_2 == 1) $checked[2] = 'checked="checked"';
	if ($newpm_default_checked_3 == 1) $checked[3] = 'checked="checked"';
	if ($newpm_default_checked_4 == 1) $checked[4] = 'checked="checked"';

	if (isset($_REQUEST['pmid'])) $pmid = intval($_REQUEST['pmid']);

	if (isset($_POST['send'])) {
		/* get subject */
		$subject = wbb_trim($_POST['subject']);

		/* get recipient */
		$recipient = wbb_trim($_POST['recipient']);

		/* get message & strip crap */
		$message = stripcrap(wbb_trim($_POST['message']));

		/* posting feature rights:start */
		if (isset($_POST['iconid']) && $wbbuserdata['can_use_pn_icons'] == 1) $iconid = intval($_POST['iconid']);
		else $iconid = 0;

		if (!$wbbuserdata['can_use_pn_smilies'] || (isset($_POST['disablesmilies']) && $_POST['disablesmilies'] == 1)) $allowsmilies = 0;
		else $allowsmilies = 1;

		if (!$wbbuserdata['can_use_pn_html'] || (isset($_POST['disablehtml']) && $_POST['disablehtml'] == 1)) $allowhtml = 0;
		else $allowhtml = 1;

		if (!$wbbuserdata['can_use_pn_bbcode'] || (isset($_POST['disablebbcode']) && $_POST['disablebbcode'] == 1)) $allowbbcode = 0;
		else $allowbbcode = 1;

		if (!$wbbuserdata['can_use_pn_images'] || (isset($_POST['disableimages']) && $_POST['disableimages'] == 1)) $allowimages = 0;
		else $allowimages = 1;
		/* posting feature rights:end */


		if (!isset($_POST['preview']) && !$_POST['change_editor']) {
			$error = '';
			if (!$subject || !$recipient || !$message) $error .= $lang->items['LANG_POSTINGS_ERROR1'];

			/* check recipient */
			if ($recipient) {
				$result = getwbbuserdata($recipient, "username");

				if (!$result['userid']) $error .= $lang->get("LANG_PMS_ERROR1", array('$recipient' => $recipient));
				else {
					if (($result['receivepm'] == 0 || $result['can_use_pms'] == 0) && $wbbuserdata['a_can_ignore_maxpms'] != 1) $error .= $lang->get("LANG_PMS_ERROR2", array('$recipient' => $recipient));
					if (add2list($result['ignorelist'], $wbbuserdata['userid']) == -1) $error .= $lang->get("LANG_PMS_ERROR3", array('$recipient' => $recipient));

					list($countpms) = $db->query_first("SELECT COUNT(*) FROM bb".$n."_privatemessage WHERE (recipientid='$result[userid]' AND deletepm<>1) OR (senderid='$result[userid]'  AND deletepm<>2)");
					if ($wbbuserdata['a_can_ignore_maxpms'] != 1 && $result['a_can_ignore_maxpms'] != 1) {
						if ($countpms >= $maxpms) $error .= $lang->get("LANG_PMS_ERROR4", array('$recipient' => $recipient));
					}
				}

				if ($_POST['savecopy'] == 1) {
					list($countmsg) = $db->query_first("SELECT COUNT(*) FROM bb".$n."_privatemessage WHERE (recipientid='$wbbuserdata[userid]' AND deletepm<>1) OR (senderid='$wbbuserdata[userid]'  AND deletepm<>2)");
					if ($wbbuserdata['a_can_ignore_maxpms'] != 1) {
						if ($countmsg >= $maxpms) $error .= $lang->items['LANG_PMS_ERROR5'];
					}
				}
			}

			if ($error) eval("\$pm_error = \"".$tpl->get("newthread_error")."\";");

			else {
				/* parse url */
				if ($_POST['parseurl'] == 1) $message = parseURL($message);

				/* pm already exists? */
				$check = $db->query_first("SELECT privatemessageid FROM bb".$n."_privatemessage WHERE senderid='$wbbuserdata[userid]' AND recipientid='$result[userid]' AND subject='".addslashes($subject)."' AND message = '".addslashes($message)."' AND iconid='$iconid' AND sendtime>='".(time() - $dpvtime)."'");
				if ($check['privatemessageid']) {
					header("Location: pms.php".$SID_ARG_1ST);
					exit;
				}

				/* insert pm */
				$db->unbuffered_query("INSERT INTO bb".$n."_privatemessage (senderid,recipientid,subject,message,sendtime,allowsmilies,allowhtml,allowbbcode,allowimages,showsignature,iconid,deletepm,tracking) VALUES ('$wbbuserdata[userid]','$result[userid]','".addslashes($subject)."','".addslashes($message)."','".time()."','$allowsmilies','$allowhtml','$allowbbcode','$allowimages','".intval($_POST['showsignature'])."','$iconid','".(($_POST['savecopy'] == 1) ? (0) : (2))."','".intval($_POST['tracking'])."')", 1);

				/* set popup for recipient */
				if ($result['pmpopup'] == 1) $db->unbuffered_query("UPDATE bb".$n."_users SET pmpopup=2 WHERE userid='$result[userid]'", 1);

				/* email notification for recipient */
				if ($result['emailonpm'] == 1) {
					if ($result['languagepackid'] == $lang->languagepackid) $userlang = $lang;
					else {
						$userlang = &new language(intval($result['languagepackid']));
						$userlang->load("OWN,MAIL");
					}

					$master_board_name_email = getlangvar($o_master_board_name, $userlang, 0);

					$mail_text = $userlang->get("LANG_MAIL_NEWPM_TEXT", array('$username' => $result['username'], '$sender' => $wbbuserdata['username'], '$url2board' => $url2board, '$master_board_name_email' => $master_board_name_email));
					$mail_subject = $userlang->get("LANG_MAIL_NEWPM_SUBJECT", array('$master_board_name_email' => $master_board_name_email));
					mailer($result['email'], $mail_subject, $mail_text);
				}

				if ($_REQUEST['action'] == "replypm") $db->unbuffered_query("UPDATE bb".$n."_privatemessage SET reply=1 WHERE privatemessageid='$pmid' AND recipientid='$wbbuserdata[userid]'", 1);
				if ($_REQUEST['action'] == "forwardpm") $db->unbuffered_query("UPDATE bb".$n."_privatemessage SET forward=1 WHERE privatemessageid='$pmid' AND recipientid='$wbbuserdata[userid]'", 1);
				header("Location: pms.php".$SID_ARG_1ST);
				exit;
			}
		}
		else if (!$_POST['change_editor']) {
			$parse = &new parse($docensor, 75, $wbbuserdata['showimages'], "", $usecode);
			$preview_subject = htmlconverter(textwrap($subject));
			$preview_message = $parse->doparse((($_POST['parseurl'] == 1) ? (parseURL($message)) : ($message)), $allowsmilies, $allowhtml, $allowbbcode, $allowimages);
			if ($iconid) {
				$result = $db->query_first("SELECT * FROM bb".$n."_icons WHERE iconid = '$iconid'");
				$preview_posticon = makeimgtag($result['iconpath'], getlangvar($result['icontitle'], $lang), 0);
			}
		}
		if ($_POST['parseurl'] == 1) $checked[0] = 'checked="checked"';
		else $checked[0] = '';
		if ($_POST['disablesmilies'] == 1) $checked[1] = 'checked="checked"';
		else $checked[1] = '';
		if ($_POST['showsignature'] == 1) $checked[5] = 'checked="checked"';
		else $checked[5] = '';
		if ($_POST['savecopy'] == 1) $checked[6] = 'checked="checked"';
		else $checked[6] = '';
		if ($_POST['tracking'] == 1) $checked[7] = 'checked="checked"';
		else $checked[7] = '';

		if ($_POST['disablehtml'] == 1) $checked[2] = 'checked="checked"';
		else $checked[2] = '';
		if ($_POST['disablebbcode'] == 1) $checked[3] = 'checked="checked"';
		else $checked[3] = '';
		if ($_POST['disableimages'] == 1) $checked[4] = 'checked="checked"';
		else $checked[4] = '';
	}
	else {
		if (isset($_GET['userid'])) list($recipient) = $db->query_first("SELECT username FROM bb".$n."_users WHERE userid='".intval($_GET['userid'])."'");
		if ($_REQUEST['action'] == 'replypm' || $_REQUEST['action'] == 'forwardpm') {
			$pm = $db->query_first("SELECT p.senderid, p.subject, p.message, p.sendtime, u.username FROM bb".$n."_privatemessage p LEFT JOIN bb".$n."_users u ON (u.userid=p.senderid) WHERE p.privatemessageid='$pmid' AND p.recipientid='$wbbuserdata[userid]'");
			$sendtime = formatdate($wbbuserdata['dateformat']." ".$wbbuserdata['timeformat'], $pm['sendtime']);
			if ($docensor == 1) {
				if ($parse) $pm['message'] = $parse->censor($pm['message']);
				else {
					$parse = &new parse(1);
					$pm['message'] = $parse->censor($pm['message']);
				}
			}

			if ($_REQUEST['action'] == 'replypm') {
				$pm['subject'] = preg_replace("/^RE: /i", "", $pm['subject']);
				
				$subject = $lang->get("LANG_PMS_RE", array('$subject' => $pm['subject']));
				$message = $lang->get("LANG_PMS_ORIGINAL_MESSAGE", array('$subject' => $pm['subject'], '$username' => $pm['username'], '$sendtime' => $sendtime, '$sender' => $wbbuserdata['username'], '$message' => $pm['message']));
				$recipient = $pm['username'];
			}
			if ($_REQUEST['action'] == 'forwardpm') {
				$pm['subject'] = preg_replace("/^FW: /i", "", $pm['subject']);
				
				$subject = $lang->get("LANG_PMS_FW", array('$subject' => $pm['subject']));
				$message = $lang->get("LANG_PMS_ORIGINAL_MESSAGE", array('$subject' => $pm['subject'], '$username' => $pm['username'], '$sendtime' => $sendtime, '$sender' => $wbbuserdata['username'], '$message' => $pm['message']));
			}
		}
	}

	if (!isset($iconid)) $iconid = 0;
	if ($wbbuserdata['can_use_pn_icons'] == 1) $pm_icons = getIcons($iconid);
	if ($wbbuserdata['can_use_pn_bbcode'] == 1 && $wbbuserdata['usewysiwyg'] != 1) $bbcode_buttons = getcodebuttons();
	if ($wbbuserdata['can_use_pn_smilies'] == 1) {
		if ($wbbuserdata['usewysiwyg'] == 1) $smilies = getAppletSmilies();
		$bbcode_smilies = getclickysmilies($smilie_table_cols, $smilie_table_rows);
	}

	$note = '';
	if ($wbbuserdata['can_use_pn_html'] == 0) $note .= $lang->items['LANG_POSTINGS_HTML_NOT_ALLOW'];
	else $note .= $lang->items['LANG_POSTINGS_HTML_ALLOW'];
	if ($wbbuserdata['can_use_pn_bbcode'] == 0) $note .= $lang->items['LANG_POSTINGS_BBCODE_NOT_ALLOW'];
	else $note .= $lang->items['LANG_POSTINGS_BBCODE_ALLOW'];
	if ($wbbuserdata['can_use_pn_smilies'] == 0) $note .= $lang->items['LANG_POSTINGS_SMILIES_NOT_ALLOW'];
	else $note .= $lang->items['LANG_POSTINGS_SMILIES_ALLOW'];
	if ($wbbuserdata['can_use_pn_images'] == 0) $note .= $lang->items['LANG_POSTINGS_HTML_IMAGES_ALLOW'];
	else $note .= $lang->items['LANG_POSTINGS_IMAGES_ALLOW'];

	if (isset($message)) $message = htmlconverter($message);
	if (isset($subject)) $subject = htmlconverter($subject);
	if (isset($recipient)) $recipient = htmlconverter($recipient);

	eval("\$headinclude .= \"".$tpl->get("bbcode_script")."\";");
	eval("\$editor = \"".$tpl->get("editor")."\";");
	eval("\$tpl->output(\"".$tpl->get("pms_newpm")."\");");
	exit;
}

/** stop tracking **/
if (isset($_POST['action']) && $_POST['action'] == 'endtracking') {
	if ($_POST['pmid'] && count($_POST['pmid'])) $pmids = implode(',', $_POST['pmid']);
	else $pmids = '';
	if ($pmids) $db->unbuffered_query("UPDATE bb".$n."_privatemessage SET tracking=0 WHERE senderid='$wbbuserdata[userid]' AND privatemessageid IN (".addslashes($pmids).")", 1);

	header("Location: pms.php?action=tracking".$SID_ARG_2ND_UN);
	exit;
}

/** cancel message **/
if (isset($_POST['action']) && $_POST['action'] == 'cancel') {
	if ($_POST['pmid'] && count($_POST['pmid'])) $pmids = implode(',', $_POST['pmid']);
	else $pmids = '';
	if ($pmids) {
		$recipientids = '';
		$result = $db->query("SELECT DISTINCT recipientid FROM bb".$n."_privatemessage WHERE senderid='$wbbuserdata[userid]' AND privatemessageid IN (".addslashes($pmids).") AND view=0");
		while ($row = $db->fetch_array($result)) $recipientids .= ",".$row['recipientid'];
		$db->unbuffered_query("DELETE FROM bb".$n."_privatemessage WHERE senderid='$wbbuserdata[userid]' AND privatemessageid IN (".addslashes($pmids).") AND view=0", 1);
		if ($recipientids) {
			$result = $db->query("SELECT u.userid,COUNT(p.privatemessageid) as newpms FROM bb".$n."_users u LEFT JOIN bb".$n."_privatemessage p ON (p.recipientid=u.userid AND p.sendtime>u.lastvisit AND p.view=0 AND p.deletepm<>1) WHERE u.userid IN(0$recipientids) GROUP BY u.userid");
			$userids = '';
			while ($row = $db->fetch_array($result)) if ($row['newpms'] < 1) $userids .= ",".$row['userid'];
			if ($userids) $db->unbuffered_query("UPDATE bb".$n."_users SET pmpopup=1 WHERE userid IN (0$userids) AND pmpopup=2", 1);
		}
	}
	header("Location: pms.php?action=tracking".$SID_ARG_2ND_UN);
	exit;
}

/** download a message -> txt file **/
if (isset($_GET['action']) && $_GET['action'] == 'downloadpm') {
	$pm = $db->query_first("SELECT p.privatemessageid, p.subject, p.message, p.sendtime, u.username FROM bb".$n."_privatemessage p LEFT JOIN bb".$n."_users u ON (u.userid=p.senderid) WHERE privatemessageid='".intval($_GET['pmid'])."' AND recipientid='$wbbuserdata[userid]'");
	if (!$pm['privatemessageid']) error($lang->get("LANG_GLOBAL_ERROR_FALSELINK", array('$adminmail' => $adminmail)));
	$sendtime = formatdate($wbbuserdata['dateformat']." ".$wbbuserdata['timeformat'], $pm['sendtime']);

	$mime_type = (USR_BROWSER_AGENT == 'IE' || USR_BROWSER_AGENT == 'OPERA') ? 'application/octetstream' : 'application/octet-stream';
	$content_disp = (USR_BROWSER_AGENT == 'IE') ? 'inline; ' : 'attachment; ';
	header('Content-Type: '.$mime_type);
	header('Content-disposition: '.$content_disp.'filename="pm-'.$pm['privatemessageid'].'.txt"');
	header('Pragma: no-cache');
	header('Expires: 0');

	print($lang->get("LANG_PMS_DOWNLOAD_MESSAGE", array('$subject' => $pm['subject'], '$username' => $pm['username'], '$sendtime' => $sendtime, '$sender' => $wbbuserdata['username'], '$message' => $pm['message'])));
	exit;
}

/** delete one message **/
if ($_REQUEST['action'] == 'deletepm') {
	$pmid = intval($_REQUEST['pmid']);
	if (isset($_REQUEST['outbox'])) $outbox = intval($_REQUEST['outbox']);
	else $outbox = 0;
	if (isset($_POST['send']) && $_POST['send'] == 'send') {
		if ($outbox == 1) {
			$db->query("DELETE FROM bb".$n."_privatemessage WHERE senderid='$wbbuserdata[userid]' AND deletepm=1 AND privatemessageid='$pmid'");
			$db->unbuffered_query("UPDATE bb".$n."_privatemessage SET deletepm=2 WHERE senderid='$wbbuserdata[userid]' AND privatemessageid='$pmid'", 1);

			header("Location: pms.php?folderid=outbox".$SID_ARG_2ND_UN);
		}
		else {
			$db->query("DELETE FROM bb".$n."_privatemessage WHERE recipientid='$wbbuserdata[userid]' AND deletepm=2 AND privatemessageid='$pmid'");
			$db->unbuffered_query("UPDATE bb".$n."_privatemessage SET deletepm=1, tracking=0 WHERE recipientid='$wbbuserdata[userid]' AND privatemessageid='$pmid'", 1);
			header("Location: pms.php".$SID_ARG_1ST);
		}
		exit;
	}

	eval("\$tpl->output(\"".$tpl->get("pms_deletepm")."\");");
	exit;
}

/** print message **/
if ($_REQUEST['action'] == 'printpm') {
	$pmid = intval($_REQUEST['pmid']);
	$pm = $db->query_first("SELECT
	p.*, i.iconpath, i.icontitle,
	u.userid, u.username
	FROM bb".$n."_privatemessage p
	LEFT JOIN bb".$n."_icons i USING(iconid)
	LEFT JOIN bb".$n."_users u ON (p.senderid=u.userid)
	WHERE p.privatemessageid='$pmid' AND p.deletepm<>1");
	if ($pm['recipientid'] != $wbbuserdata['userid']) error($lang->get("LANG_GLOBAL_ERROR_FALSELINK", array('$adminmail' => $adminmail)));

	$senddate = formatdate($wbbuserdata['dateformat'], $pm['sendtime']);
	$sendtime = formatdate($wbbuserdata['timeformat'], $pm['sendtime']);

	if ($pm['iconid']) $icon = makeimgtag($pm['iconpath'], getlangvar($pm['icontitle'], $lang), 0);
	else $icon = '';

	$parse = &new parse($docensor, 90, $wbbuserdata['showimages'], "", $usecode);
	$pm['message'] = $parse->doparse($pm['message'], $pm['allowsmilies'], $pm['allowhtml'], $pm['allowbbcode'], $pm['allowimages']);
	$pm['subject'] = htmlconverter(textwrap($pm['subject']));

	$pm['username'] = htmlconverter($pm['username']);
	$lang->items['LANG_PMS_PRINT_MESSAGE'] = $lang->get("LANG_PMS_PRINT_MESSAGE", array('$subject' => $pm['subject'], '$username' => $pm['username'], '$senddate' => $senddate, '$sendtime' => $sendtime, '$sender' => $wbbuserdata['username']));
	eval("\$tpl->output(\"".$tpl->get("pms_printpm")."\");");
	exit;
}

/** pm popup **/
if ($_REQUEST['action'] == 'popup') {
	$result = $db->query("SELECT
	p.privatemessageid, p.subject, p.sendtime, p.iconid,
	i.iconpath, i.icontitle,
	u.userid, u.username
	FROM bb".$n."_privatemessage p
	LEFT JOIN bb".$n."_icons i USING(iconid)
	LEFT JOIN bb".$n."_users u ON (p.senderid=u.userid)
	WHERE p.recipientid='$wbbuserdata[userid]' AND p.sendtime>'$wbbuserdata[lastvisit]' AND p.view=0 AND p.deletepm<>1
	ORDER BY p.sendtime DESC");

	$pmscount = $db->num_rows($result);

	$pmbit = '';
	while ($row = $db->fetch_array($result)) {
		if ($row['iconid']) $icon = makeimgtag($row['iconpath'], getlangvar($row['icontitle'], $lang), 0);
		else $icon = "&nbsp;";

		$senddate = formatdate($wbbuserdata['dateformat'], $row['sendtime']);
		$sendtime = formatdate($wbbuserdata['timeformat'], $row['sendtime']);

		$row['subject'] = htmlconverter(textwrap($row['subject']));
		$row['username'] = htmlconverter($row['username']);

		eval("\$pmbit .= \"".$tpl->get("pmpopup_pmbit")."\";");
	}

	if ($pmscount == 1) $LANG_PMS_POPUP_MESSAGE = $lang->items['LANG_PMS_POPUP_MESSAGE'];
	else $LANG_PMS_POPUP_MESSAGES = $lang->items['LANG_PMS_POPUP_MESSAGES'];

	$lang->items['LANG_PMS_POPUP_NEWMESSAGE'] = $lang->get("LANG_PMS_POPUP_NEWMESSAGE", array('$pmscount' => $pmscount, '$LANG_PMS_POPUP_MESSAGE' => $LANG_PMS_POPUP_MESSAGE));
	eval("\$tpl->output(\"".$tpl->get("pmpopup")."\");");
	exit;
}

/** move marked msgs to x **/
if (isset($_POST['action']) && wbb_substr($_POST['action'], 0, 6) == 'moveto') {
	$tofolderid = intval(wbb_substr($_POST['action'], 7));
	if ($_POST['pmid'] && count($_POST['pmid'])) $pmids = implode(',', intval_array($_POST['pmid']));
	else $pmids = '';
	if ($pmids) {
		list($controluser) = $db->query_first("SELECT userid FROM bb".$n."_folders WHERE folderid='$tofolderid'");
		if ($controluser != $wbbuserdata['userid']) access_error();

		$db->query("UPDATE bb".$n."_privatemessage SET folderid='$tofolderid' WHERE recipientid='$wbbuserdata[userid]' AND privatemessageid IN (".addslashes($pmids).")");
	}
	header("Location: pms.php?folderid=$folderid".$SID_ARG_2ND_UN);
	exit;
}
?>